// generated by ../deps/sqlpp11/scripts/ddl2cpp memberships.sqlpp11.sql memberships wee
#ifndef WEE_MEMBERSHIPS_H
#define WEE_MEMBERSHIPS_H

#include <sqlpp11/table.h>
#include <sqlpp11/data_types.h>
#include <sqlpp11/char_sequence.h>

namespace wee
{
  namespace Memberships_
  {
    struct Id
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "id";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T id;
            T& operator()() { return id; }
            const T& operator()() const { return id; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::must_not_insert, sqlpp::tag::must_not_update>;
    };
    struct Project
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "project";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T project;
            T& operator()() { return project; }
            const T& operator()() const { return project; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::require_insert>;
    };
    struct User
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "\"user\"";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T user;
            T& operator()() { return user; }
            const T& operator()() const { return user; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::require_insert>;
    };
    struct Recruiter
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "recruiter";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T recruiter;
            T& operator()() { return recruiter; }
            const T& operator()() const { return recruiter; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::bigint, sqlpp::tag::require_insert>;
    };
    struct Since
    {
      struct _alias_t
      {
        static constexpr const char _literal[] =  "since";
        using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
        template<typename T>
        struct _member_t
          {
            T since;
            T& operator()() { return since; }
            const T& operator()() const { return since; }
          };
      };
      using _traits = sqlpp::make_traits<sqlpp::time_point>;
    };
  } // namespace Memberships_

  struct Memberships: sqlpp::table_t<Memberships,
               Memberships_::Id,
               Memberships_::Project,
               Memberships_::User,
               Memberships_::Recruiter,
               Memberships_::Since>
  {
    struct _alias_t
    {
      static constexpr const char _literal[] =  "memberships";
      using _name_t = sqlpp::make_char_sequence<sizeof(_literal), _literal>;
      template<typename T>
      struct _member_t
      {
        T memberships;
        T& operator()() { return memberships; }
        const T& operator()() const { return memberships; }
      };
    };
  };
} // namespace wee
#endif
